/* BITMAP FONTIER routines and demo */
/* By Rukshan Fonseka, requires XLIB */

#include<stdio.h>
#include<malloc.h>
#include<string.h>
#include<conio.h>
#include<xlib_all.h>
#include<dos.h>								/* required for getdate */

/* extern variables */
char far *Fonts[256];              		/* actual data */
unsigned char ColorsNO;                /* number of colors used */
unsigned char *Pal;                    /* the palette */


FILE *fp;

FatalError(char *String)
{
printf("\nERROR: %s",String);
fclose(fp);
exit(1);
}

/* simply a slooow linear bitmap displayer */
DrawChar(int x,int y,int PageOffset,char *Letter)
{
register int i,j,index=2;

for(j=0;j<Letter[1];j++)
	for(i=0;i<Letter[0];i++)
		{
		x_put_pix(i+x,j+y,PageOffset,Letter[index]);
		index++;
		}
}

/* draw a cool string */
DrawString(int x,int y,int PageOffset,char *String)
{
register int i,j=x;

for(i=0;i<strlen(String);i++)
	{
	DrawChar(j,y,PageOffset,Fonts[String[i]]);
	j+=(Fonts[String[i]][0])+1;
	}
}


/* loads a font file into mem */
LoadFontFile(char *Filename)
{
int handle,i;
char sizex,sizey;
char sig[3];

if((handle=f_open(Filename,F_RDONLY))==FILE_ERR)
	exit(0);
f_read(handle,sig,3);
if(strcmp(sig,"JRF"))
	{
	Pal=malloc(sizeof(char)*768);
	if(Pal==NULL)
		{
		f_close(handle);
		exit(0);
		}
	f_read(handle,Pal,sizeof(char)*768);
	for(i=0;i<=255;i++)
		{
		f_read(handle,&sizex,1);
		f_read(handle,&sizey,1);
		f_seek(handle,-2,SEEK_CURR);
		Fonts[i]=farmalloc(sizeof(char)*((sizex*sizey)+2));
		if(Fonts[i]==NULL)
			{
			f_close(handle);
			exit(0);
			}
		f_readfar(handle,Fonts[i],(sizex*sizey)+2);
		}
	}
f_close(handle);
}



main()
{
int i;
struct date d;
char buffer[10];

getdate(&d);
sprintf(buffer,"%d.%d.%d",d.da_day,d.da_mon,d.da_year);   /* get date */
x_set_mode(X_MODE_320x240,320);
x_text_init();
LoadFontFile("font1.fnt");                  		/* load the font file */
x_put_pal_raw(Pal,256,0);
DrawString(0,10,VisiblePageOffs,"okay");
DrawString(0,40,VisiblePageOffs,"if this is");
DrawString(0,70,VisiblePageOffs,"COOL");
DrawString(0,110,VisiblePageOffs,"great");
DrawString(0,170,VisiblePageOffs,buffer);       /* display date */
DrawString(170,180,VisiblePageOffs,"FONT1.FNT");
getch();
/* free fonts */
for(i=0;i<=255;i++)
	farfree(Fonts[i]);
/* clear the screen */
x_rect_fill(0,0,ScrnPhysicalPixelWidth,ScrnPhysicalHeight,VisiblePageOffs,0);
LoadFontFile("font2.fnt");                  		/* load the font file */
x_put_pal_raw(Pal,256,0);
DrawString(0,10,VisiblePageOffs,"but");
DrawString(0,40,VisiblePageOffs,"remember");
DrawString(0,70,VisiblePageOffs,"this");
DrawString(0,110,VisiblePageOffs,"is better !!");
DrawString(0,170,VisiblePageOffs,buffer);       /* display date */
DrawString(170,180,VisiblePageOffs,"font2.fnt");
getch();
/* clear the screen */
for(i=0;i<=255;i++)
	farfree(Fonts[i]);
x_rect_fill(0,0,ScrnPhysicalPixelWidth,ScrnPhysicalHeight,VisiblePageOffs,0);
LoadFontFile("font3.fnt");                  		/* load the font file */
x_put_pal_raw(Pal,256,0);
DrawString(0,10,VisiblePageOffs,"OKAY and alright!!!");
DrawString(0,30,VisiblePageOffs,"this is more like normal text ha!");
DrawString(0,50,VisiblePageOffs,"A simple trick, it is up to you to");
DrawString(0,70,VisiblePageOffs,"align text like you want! Here the");
DrawString(0,90,VisiblePageOffs,"text is normally aligned unlike the");
DrawString(0,110,VisiblePageOffs,"others you just saw (COOOOOL,HA)!!");
DrawString(0,170,VisiblePageOffs,buffer);       /* display date */
DrawString(170,180,VisiblePageOffs,"font3.fnt");
getch();
/* free fonts */
for(i=0;i<=255;i++)
	farfree(Fonts[i]);
x_text_mode();
}

